apiVersion: kyverno.io/v1
kind: ClusterPolicy
metadata:
  name: require-default-proc-mount
  annotations:
    policies.opencode.de/ID: "009"
    policies.opencode.de/bsi-requirement: APP.4.4.A4
    policies.kyverno.io/category: Pod Security Standards (Baseline)
    policies.kyverno.io/severity: medium
    policies.kyverno.io/subject: Pod
    policies.kyverno.io/description: >-
      The default /proc masks are set up to reduce attack surface and should be required. This policy
      ensures nothing but the default procMount can be specified.
  labels:
    policies.opencode.de/bsi-protection-requirement: basic
    policies.opencode.de/category: must
spec:
  validationFailureAction: Audit
  background: true
  rules:
    - name: check-proc-mount
      match:
        any:
          - resources:
              kinds:
                - Pod
      validate:
        message: >-
          Changing the proc mount from the default is not allowed. The fields
          spec.containers[*].securityContext.procMount and
          spec.initContainers[*].securityContext.procMount must not be changed
          from `Default`.
        pattern:
          spec:
            =(initContainers):
              - =(securityContext):
                  =(procMount): "Default"
            containers:
              - =(securityContext):
                  =(procMount): "Default"
